#! /bin/bash
#  Purpose of the script is to automatically create set of rules of various length based on two base rules

#  We want to start with an empty file
/usr/bin/rm -f /home/tdosek/privGit/scripts/rules
echo Creating file with rules.
/usr/bin/touch /home/tdosek/privGit/scripts/rules

#  Injection of basic rules that are used for further generating
/usr/bin/echo Injecting basic rules used by generator
echo "IP (?<![0-9])(?:(?:25[0-5]|2[0-4][0-9]|[0-1]?[0-9]{1,2})[.](?:25[0-5]|2[0-4][0-9]|[0-1]?[0-9]{1,2})[.](?:25[0-5]|2[0-4][0-9]|[0-1]?[0-9]{1,2})[.](?:25[0-5]|2[0-4][0-9]|[0-1]?[0-9]{1,2}))(?![0-9])" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "WORD \b\w+\b" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "BASE10NUM (?<![0-9.+-])(?>[+-]?(?:(?:[0-9]+(?:\.[0-9]+)?)|(?:\.[0-9]+)))" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "NUMBER (?:%{BASE10NUM})" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "MONTHDAY (?:3[01]|[1-2]?[0-9]|0?[1-9])" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "NOTSPACE \S+" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "SPACE \s*" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "DATA .*?" >> /home/tdosek/privGit/scripts/rules
/usr/bin/echo "CISCOMAC (?:(?:[A-Fa-f0-9]{4}\.){2}[A-Fa-f0-9]{4})" >> /home/tdosek/privGit/scripts/rules

#  BASE of types used for rule generating - if the number in comment matches the l variable in generator, 
#  the pattern will get added
#  1
IP="%{IP}" 
#  2
WORD="%{WORD:verb}" 
#  3
NUM="%{NUMBER:response}" 
#  4
MOND="%{MONTHDAY}"
#  5
NOSP="%{NOTSPACE}"
#  6
SP="%{SPACE}"
#  7
DATA="%{DATA}"
#  8
CISC="%{CISCOMAC}"


#  Generating 999995 rules
/usr/bin/echo Generating rules
for i in {1..999995}; 
do
   generated=""
   # Generating random number - amount of subtypes from base used for the rule length
   j=$(( (RANDOM % 15) + 1 ))   
   for k in $(eval echo {$j..1}); 
   do
      #  Generating random number - base pattern used
      l=$(( (RANDOM % 8) + 1 ))
      case $l in
         1) generated="$generated $IP";
         ;;
         2) generated="$generated $WORD";
         ;;
         3) generated="$generated $NUM";
         ;;
         4) generated="$generated $MOND";
         ;;
         5) generated="$generated $NOSP";
         ;;
         6) generated="$generated $SP";
         ;;
         7) generated="$generated $DATA";
         ;;
         8) generated="$generated $CISC";
         ;;
      esac
   done
   /usr/bin/echo rule$i $generated >> /home/tdosek/privGit/scripts/rules;
done
